// Author: Mr.Un1k0d3r RingZer0 Team

import java.io.PrintStream;
import sun.misc.UUDecoder;

public class DecryptCFMX6Password
{

    public DecryptCFMX6Password()
    {
    }

    public static void main(String args[])
    {
        try
        {
            System.out.println("ColdFusion MX6 Password decryptor.\nAuthor Mr.Un1k0d3r & Psychan RingZer0 Team 2014\n");
            Cryptor cryptor = new Cryptor();
            byte uudecoded[] = (new UUDecoder()).decodeBuffer(cryptor.makeBuffer(args[0]));
            System.out.println((new StringBuilder()).append("Uudecoded password:").append(new String(uudecoded)).toString());
            String key = "admin";
            String output = new String(cryptor.transformString(key, uudecoded));
            System.out.println((new StringBuilder()).append("Decrypted password: ").append(output).toString());
        }
        catch(Exception exception)
        {
            System.out.println("Usage: DecryptCFPassword [uuencoded password]");
        }
    }
}

final class Cryptor
{

    public Cryptor()
    {
        m_LFSR_A = 0x13579bdf;
        m_LFSR_B = 0x2468ace0;
        m_LFSR_C = 0xfdb97531;
        m_Mask_A = 0x80000062;
        m_Mask_B = 0x40000020;
        m_Mask_C = 0x10000002;
        m_Rot0_A = 0x7fffffff;
        m_Rot0_B = 0x3fffffff;
        m_Rot0_C = 0xfffffff;
        m_Rot1_A = 0x80000000;
        m_Rot1_B = 0xc0000000;
        m_Rot1_C = 0xf0000000;
    }

    public String makeBuffer(String s)
    {
        return (new StringBuilder()).append("begin 644 encoder.buf\n").append(s).append("\n \nend\n").toString();
    }

    public byte[] transformString(String s, byte abyte0[])
    {
        setKey(s);
        int i = abyte0.length;
        byte abyte1[] = new byte[i];
        for(int j = 0; j < i; j++)
            abyte1[j] = transformByte(abyte0[j]);

        return abyte1;
    }

    private byte transformByte(byte byte0)
    {
        boolean flag = false;
        byte byte1 = 0;
        int j = m_LFSR_B & 1;
        int k = m_LFSR_C & 1;
        for(int i = 0; i < 8; i++)
        {
            if(0 != (m_LFSR_A & 1))
            {
                m_LFSR_A = m_LFSR_A ^ m_Mask_A >>> 1 | m_Rot1_A;
                if(0 != (m_LFSR_B & 1))
                {
                    m_LFSR_B = m_LFSR_B ^ m_Mask_B >>> 1 | m_Rot1_B;
                    j = 1;
                } else
                {
                    m_LFSR_B = m_LFSR_B >>> 1 & m_Rot0_B;
                    j = 0;
                }
            } else
            {
                m_LFSR_A = m_LFSR_A >>> 1 & m_Rot0_A;
                if(0 != (m_LFSR_C & 1))
                {
                    m_LFSR_C = m_LFSR_C ^ m_Mask_C >>> 1 | m_Rot1_C;
                    k = 1;
                } else
                {
                    m_LFSR_C = m_LFSR_C >>> 1 & m_Rot0_C;
                    k = 0;
                }
            }
            byte1 = (byte)(byte1 << 1 | j ^ k);
        }

        byte0 ^= byte1;
        return byte0;
    }

    private void setKey(String s)
    {
        boolean flag = false;
        m_Key = s;
        if(0 == s.length())
            s = "Default Seed";
        char ac[] = new char[s.length() < 12 ? 12 : s.length()];
        m_Key.getChars(0, m_Key.length(), ac, 0);
        int k = m_Key.length();
        for(int i = 0; k + i < 12; i++)
            ac[k + i] = ac[i];

        for(int j = 0; j < 4; j++)
        {
            m_LFSR_A = (m_LFSR_A <<= 8) | ac[j + 4];
            m_LFSR_B = (m_LFSR_B <<= 8) | ac[j + 4];
            m_LFSR_C = (m_LFSR_C <<= 8) | ac[j + 4];
        }

        if(0 == m_LFSR_A)
            m_LFSR_A = 0x13579bdf;
        if(0 == m_LFSR_B)
            m_LFSR_B = 0x2468ace0;
        if(0 == m_LFSR_C)
            m_LFSR_C = 0xfdb97531;
    }

    private String m_Key;
    private int m_LFSR_A;
    private int m_LFSR_B;
    private int m_LFSR_C;
    private int m_Mask_A;
    private int m_Mask_B;
    private int m_Mask_C;
    private int m_Rot0_A;
    private int m_Rot0_B;
    private int m_Rot0_C;
    private int m_Rot1_A;
    private int m_Rot1_B;
    private int m_Rot1_C;
}
